image: python:3.6

stages:
  - tests
  - deploy

cache:
  key: pip
  paths:
    - .pip

before_script:
  - mkdir -p .pip
  - pip install -U pip
  - pip --cache-dir=.pip --quiet install tox twine

py36:
  stage: tests
  image: python:3.6
  coverage: '/^TOTAL\s+\d+\s+\d+\s+(\d+\%)$/'
  artifacts:
    paths:
      - htmlcov
  tags:
    - docker
  script:
    - tox

py37:
  stage: tests
  image: python:3.7
  coverage: '/^TOTAL\s+\d+\s+\d+\s+(\d+\%)$/'
  artifacts:
    paths:
      - htmlcov
  tags:
    - docker
  script:
    - tox

py38:
  stage: tests
  image: python:3.8
  coverage: '/^TOTAL\s+\d+\s+\d+\s+(\d+\%)$/'
  artifacts:
    paths:
      - htmlcov
  tags:
    - docker
  script:
    - tox

pypi:
  stage: deploy
  tags:
    - docker
  only:
    refs:
      - tags
    variables:
      - $CI_COMMIT_REF_NAME =~ /^v(\d+)(\.\d+)+?$/
  variables:
    TWINE_USERNAME: $PYPI_USERNAME
    TWINE_PASSWORD: $PYPI_PASSWORD
    PBR_VERSION: $CI_COMMIT_REF_NAME
  script:
    - '[[ -z $TWINE_USERNAME ]] && (echo "\$PYPI_USERNAME is not set" ; exit 1)'
    - '[[ -z $TWINE_PASSWORD ]] && (echo "\$PYPI_PASSWORD is not set" ; exit 1)'
    - python setup.py -q sdist bdist_wheel
    - twine upload dist/*